from UserStore import UserStore
from WMCore.Configuration import loadConfigurationFile
from crypt import crypt

class FileUserStore(UserStore):
    def load(self, user):
        cfg = loadConfigurationFile(self.store)
        user = cfg.Users.section_(user)
        # Cannot pass non str objects since the openid library does a call
        # for object.encode('UTF-8') when preparing the response to send
        return {'permissions'  : user.permissions.dictionary_(),
                'fullname'  : user.fullname,
                'dn'  : user.dn
                }
   
    def checkpass(self, username, password):
        cfg = loadConfigurationFile(self.store)
        user = cfg.Users.section_(username)
        if hasattr(user,'password'):
            if user.password == crypt (password, user.password):
                return True
        return False
    
    def checkdn(self, username, dn):
        cfg = loadConfigurationFile(self.store)
        user = cfg.Users.section_(username)
        if user and user.dn == dn: # The claimed id matches the provided DN 
            return True
        return False

    def getuserbydn(self, dn):
        cfg = loadConfigurationFile(self.store)
        user = [sec._internal_name for sec in cfg.Users if hasattr(sec, 'dn') and sec.dn == dn]
        if len(user):
            return user[0]
        return None
